//
//  LuckDrawView.m
//  choujiang
//
//  Created by MAC on 2020/11/19.
//

#import "LuckDrawView.h"
#import "PrizeView.h"
#define SCREEN_WIDTH ([UIScreen mainScreen].bounds.size.width)
#define SCREEN_HEIGHT ([UIScreen mainScreen].bounds.size.height)
@interface LuckDrawView (){
    NSTimer *startTimer;
    int currentTime;
    UIButton *startBtn;
}
/** 速度 */
@property (assign, nonatomic) CGFloat speedTime;

/** 停止时间 */
@property (nonatomic, assign) NSInteger stopTime;
/** 礼品数组 */
@property (nonatomic, strong) NSArray *prizeViews;
@end

@implementation LuckDrawView
- (instancetype)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        self.backgroundColor = [UIColor blackColor];
        currentTime = 0;
        //self.stopCount = 0;
        
        self.speedTime = 0.1;
    }
    return self;
}
- (void)setStopCount:(NSInteger)stopCount {
    _stopCount = stopCount;
    self.stopTime = 39 + _stopCount;
}
- (void)initLuckDrawView {
    CGFloat width = self.frame.size.width;
    CGFloat topMarge = 1; //距离顶部边距
    CGFloat leftMarge = 1; //距离左边距
    CGFloat space = 1; //之间的距离
    CGFloat prizeW = (width - leftMarge * 2 - space * 2)/3;
    
    NSMutableArray *views = [[NSMutableArray alloc] init];
    for (int i=0; i<9; i++) {
        CGFloat x = leftMarge + space * (i % 3) + (i % 3) * prizeW;
        CGFloat y = topMarge + space * (i / 3) + (i / 3) * prizeW;
        if ( i==4 ) {    //中间抽奖按钮
            startBtn = [[UIButton alloc] initWithFrame:CGRectMake(x, y, prizeW, prizeW)];
            startBtn.backgroundColor = [UIColor redColor];
            [startBtn setTitle:@"抽奖" forState:UIControlStateNormal];
            [startBtn addTarget:self action:@selector(onStartButtonClick:) forControlEvents:UIControlEventTouchUpInside];
            [self addSubview:startBtn];
        } else {    //奖品
            PrizeView *view = [[PrizeView alloc] initWithFrame:CGRectMake(x, y, prizeW, prizeW)];
            view.name = self.prizeNames[i];
            view.imgString = @"ditu";
            [self addSubview:view];
            [views addObject:view];
        }
    }
    self.prizeViews = views;
    /**
     位置变换
     0  5  4        0  1  2
     2  *  3   =>   7  *  3
     5  6  1        6  5  4
     */
    [self TradePlacesWithPrizeView1:self.prizeViews[3] PrizeView2:self.prizeViews[4]];
    [self TradePlacesWithPrizeView1:self.prizeViews[4] PrizeView2:self.prizeViews[7]];
    [self TradePlacesWithPrizeView1:self.prizeViews[5] PrizeView2:self.prizeViews[6]];

}

- (void)TradePlacesWithPrizeView1:(PrizeView *)firstView PrizeView2:(PrizeView *)secondView {
    CGRect frame = firstView.frame;
    firstView.frame = secondView.frame;
    secondView.frame = frame;
}
/** 抽奖按钮 */
- (void)onStartButtonClick:(UIButton *)btn {
    [btn setEnabled:NO];
    dispatch_async(dispatch_get_global_queue(0, 0), ^{
        self->startTimer = [NSTimer scheduledTimerWithTimeInterval:self.speedTime target:self selector:@selector(start:) userInfo:nil repeats:YES];
        [[NSRunLoop currentRunLoop] run];
    });
}
/** 开始 */
- (void)start:(NSTimer *)timer {
    PrizeView *oldView = [self.prizeViews objectAtIndex:currentTime % self.prizeViews.count];
    currentTime++;
    PrizeView *prizeView = [self.prizeViews objectAtIndex:currentTime % self.prizeViews.count];
    dispatch_async(dispatch_get_main_queue(), ^{
        oldView.isSelect = NO;
        prizeView.isSelect = YES;
    });
    
    if (currentTime > self.stopTime) { //抽奖结果
        self.stopCount = [self.prizeViews indexOfObject:prizeView];
        currentTime = 0;
        self.stopTime = 39 + self.stopCount;
        self.speedTime = 0.1;
        [startBtn setEnabled:YES];
        NSLog(@"抽到的位置：%ld， stopTime：%ld", self.stopCount, self.stopTime);
        [timer invalidate];
        [self showAlerts:[NSString stringWithFormat:@"恭喜您获得%@", prizeView.name]];
        return;
    }
    
    if (currentTime > self.stopTime - 10) {
        self.speedTime += 0.01 * (currentTime + 10 - self.stopTime); //动画效果由快变慢
        [timer invalidate];
        
        dispatch_async(dispatch_get_global_queue(0, 0), ^{
            self->startTimer = [NSTimer scheduledTimerWithTimeInterval:self.speedTime target:self selector:@selector(start:) userInfo:nil repeats:YES];
            [[NSRunLoop currentRunLoop] run];
        });
    }
}

- (void)showAlerts:(NSString *)message {
    NSLog(@"=====%@",message);
}

- (UIViewController *)viewController {
    for (UIView* next = [self superview]; next; next = next.superview) {
        UIResponder *nextResponder = [next nextResponder];
        if ([nextResponder isKindOfClass:[UIViewController class]]) {
            return (UIViewController *)nextResponder;
        }
    }
    return nil;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
